/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 195 by dpavlin, Wed Mar 24 19:03:16 2010 UTC revision 237 by dpavlin, Wed Jan 26 18:56:17 2011 UTC
# Line 40  lxc_rootfs() { Line 40  lxc_rootfs() {
40          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                  boot="    "                  boot="-"
59                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                  echo "$name $status $boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61          done          done ) | column -t
62  }  }
63    
64    
# Line 54  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
76    
77            echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79  }  }
80    
81    
# Line 68  setup_inittab() { Line 86  setup_inittab() {
86    
87          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
88          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
89          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
91                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
92                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 106  lxc_stop() { Line 124  lxc_stop() {
124    
125  lxc_start() {  lxc_start() {
126          name=$1          name=$1
127            rootfs=$(lxc_rootfs $1)
128    
129            if [ ! -e $rootfs ] ; then
130                    echo "ERROR $name rootfs $rootfs not found"
131                    return
132            fi
133    
134          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
135                  lxc_log "$name start"                  lxc_log "$name start"
# Line 123  rootfs=$(lxc_rootfs $1) Line 147  rootfs=$(lxc_rootfs $1)
147  while true; do  while true; do
148          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
149          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
150            stop_on=1 # init
151            sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
152            if [ "$sulogins" -gt 0 ] ; then
153                    stop_on=`expr $stop_on + $sulogins`
154            fi
155    
156          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
157          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
158    
159                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
160                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
# Line 152  while true; do Line 182  while true; do
182                  ;;                  ;;
183                  esac                  esac
184          else          else
185                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
186          fi          fi
187    
188          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...

Legend:
Removed from v.195  
changed lines
  Added in v.237

  ViewVC Help
Powered by ViewVC 1.1.26